# Retrieve the system environment variable
 if (dir.exists("W:/Projects/ASOS"))
 {WERinR<-"W:"}else{WERinR<-Sys.getenv("WERinR2_Root")}		
 setwd(file.path(WERinR,"Demos/EVA"))	# Set the working directory
 getwd()
 source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
 Print<-function(x) {cat(x,"\n");  flush.console()}
 library(akima)

 print(load("EpochBoot.Rdata"))

 ws<-unique(means$w)
 Rs<-unique(means$R)
 PIs<-unique(means$PI)
 nw<-length(ws)
 nR<-length(Rs)
 nPI<-length(PIs)

SVG=FALSE

MRI=50
method<-"X"
Name<-paste(method,MRI,sep="")
levels<-c(-1,0,1,2,5)
levels<-c(levels/10000,levels/1000,levels/100,levels/10,levels,levels*10,levels*100)
pal = col = hcl.colors(100, "YlOrRd", rev = TRUE)

#=========================================================================
#		Bias and variance for each PI
#-------------------------------------------------------------------------
graphics.off()
# mean bias
for (PI in PIs)
{Lim=c(-0.2,1)
 Mx<-means[means$PI==PI,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qximis(-log(-log(1-1/MRI)),c(PI,1,Mx[i,"w"]))
 V<-V/Vtgt-1
 mx<-interp(Mx$R,Mx$w,V,nx=nR*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("Bias.",Name,".PI",PI,".svg",sep=""))}else{dev.new()}
 image(mx,main=paste("Bias error of",Name,"for PI =",PI),
    ylab="Index, w",xlab="Epochs, R",xlim=range(Rs),ylim=range(ws),col=pal,zlim=Lim)
 contour(mx,add=TRUE,labcex=1,lwd=2,levels=levels)
 mtext(paste("Mean bias error / V",MRI,sep="")) 
# contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
 if (SVG)dev.off()
}

graphics.off()
# variances
for (PI in PIs)
{Lim=c(log(1e-5),log(10))
 Mx<-variances[variances$PI==PI,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qximis(-log(-log(1-1/MRI)),c(PI,1,Mx[i,"w"]))
 V<-sqrt(V)/Vtgt
 mx<-interp(Mx$R,Mx$w,V,nx=nR*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("StdErr.",Name,".PI",PI,".svg",sep=""))}else{dev.new()} 
 image(mx$x,mx$y,log(mx$z),main=paste("Standard error of",Name,"for PI =",PI),
    ylab="Index, w",xlab="Epochs, R",xlim=range(Rs),ylim=range(ws),zlim=Lim,col=pal)
 contour(mx,add=TRUE,labcex=1,lwd=2,levels=levels)
 box(lwd=2)
 mtext(paste("Standard deviation / V",MRI,sep="")) 
 if (SVG)dev.off()
}


#=========================================================================
#		Bias and variance for each R
#-------------------------------------------------------------------------
graphics.off()
# mean bias
for (R in Rs)
{Lim=c(-0.2,1)
 Mx<-means[means$R==R,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qximis(-log(-log(1-1/MRI)),c(Mx[i,"PI"],1,Mx[i,"w"]))
 V<-(V/Vtgt)-1
 mx<-interp(Mx$PI,Mx$w,V,nx=nPI*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("Epoch.Bias.",Name,".R",R,".svg",sep=""))}else{dev.new()}
# image(mx,main=bquote(bold("Bias error of"~.(Name)~"for "~italic(R)==.(R))),
#    ylab=expression("Weibull index, "~italic(w)),
#    xlab=expression("Characteristic product, "~italic(Pi)),zlim=Lim,col=pal)
# contour(mx,add=TRUE,labcex=1,lwd=2,levels=levels)

 contour(mx,labcex=1,lwd=2,levels=levels,
   main=bquote(bold("Bias error of"~.(Name)~"for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
   xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext(bquote(bar(epsilon)(italic(V)[.(MRI)])/~italic(V)[.(MRI)]))
 if (SVG)dev.off()
}

graphics.off()
# variances
for (R in Rs)
{Lim=c(log(1e-5),log(10))
 Mx<-variances[variances$R==R,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qximis(-log(-log(1-1/MRI)),c(Mx[i,"PI"],1,Mx[i,"w"]))
 V<-sqrt(V)/Vtgt
 mx<-interp(Mx$PI,Mx$w,V,nx=nPI*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("Epoch.StdErr.",Name,".R",R,".svg",sep=""))}else{dev.new()} 
# image(mx$x,mx$y,log(mx$z),
#  main=bquote(bold("Standard error of"~.(Name)~"for "~italic(R)==.(R))),
#    ylab=expression("Weibull index, "~italic(w)),
#    xlab=expression("Characteristic product, "~italic(Pi)),zlim=Lim,col=pal)
# contour(mx,add=TRUE,labcex=1,lwd=2,levels=levels)

 contour(mx,labcex=1,lwd=2,levels=levels,
 main=bquote(bold("Standard error of"~.(Name)~"for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
    xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext(bquote(bar(sigma)(italic(V)[.(MRI)])/~italic(V)[.(MRI)]))
 if (SVG)dev.off()
}



graphics.off()
# GEV shape parameter for Weibull index
for (w in ws)
{M<-means[means$w==w,]
 mx<-interp(M$R,M$PI,M$shp,nx=nR*10,ny=nPI*10,linear=TRUE)
 dev.new()
 image(mx,main=paste("GEV shape parameter for w =",w),xlab="Epochs, R",
   ylab="Characteristic product, PI",col=rev(col),log="y")
 abline(h=c(1:15),col="grey")
 contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
}

graphics.off()
# GEV shape parameter for R
for (R in Rs)
{M<-means[means$R==R,]
 mx<-interp(M$PI,M$w,M$shp,nx=nPI*10,ny=nw*10,linear=TRUE)
 dev.new()
# image(mx,main=bquote(bold("GEV shape parameter "~italic(xi)~" for "~italic(R)==.(R))),
#    ylab=expression("Weibull index, "~italic(w)),
#    xlab=expression("Characteristic product, "~italic(Pi)),col=col)
# contour(mx,add=TRUE,labcex=1,lwd=2,levels=seq(-0.4,0.4,0.02))

# svg(paste("Epoch.ShapeGEV.R",R,".svg",sep=""))

 contour(mx,labcex=1,lwd=2,levels=seq(-0.4,0.4,0.02),
   main=bquote(bold("GEV shape parameter "~italic(xi)~" for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
    xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext("Weighted LMS fit to GEV")
# dev.off()
}

graphics.off()
# GRW index for Weibull index
for (w in ws)
{M<-means[means$w==w,]
 mx<-interp(M$R,M$PI,M$wgrw,nx=nR*10,ny=nPI*10,linear=TRUE)
 dev.new()
 image(mx,main=paste("Gringorten-Cook-Harris Index for w =",w),
   xlab="Epochs, R",ylab="Characteristic product, PI",col=col)
# abline(h=c(1:15),col="grey")
 contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
}

graphics.off()
# GRW index for R
for (R in Rs)
{M<-means[means$R==R,]
 mx<-interp(M$PI,M$w,M$wgrw,ny=nw*10,nx=nPI*10,linear=TRUE)
 dev.new()
# image(mx,main=bquote(bold("Gringorten-Cook-Harris Index "~italic(w)~" for "~italic(R)==.(R))),
#    ylab=expression("Weibull index, "~italic(w)),
#    xlab=expression("Characteristic product, "~italic(Pi)),col=col)
# contour(mx,add=TRUE,labcex=1,lwd=2)

# svg(paste("Epoch.IndexGRW.R",R,".svg",sep=""))
 contour(mx,labcex=1,lwd=2,
   main=bquote(bold("Gringorten-Cook-Harris Index "~italic(w)~" for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
    xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext("Weighted LMS fit to penultimate FT1")
# dev.off()
}

cubit<-function(col)
 {array(col,c(nPI,nR,nw),dimnames=list(PI=PIs,R=Rs,w=ws))}

# GEV shape convergence
Ax<-cubit(means$shp)
mx<-apply(Ax,c(1,3),mean)
plot(PIs,mx[,3],lwd=2,typ="b",xlab="Characteristic product, PI",
  ylim=c(-0.1,0),
  ylab="GEV shape factor",main="GEV shape factor convergence" )
for (w in c(5:length(ws)))
 points(PIs,mx[,w],typ="b",pch=w)
abline(h=0)

# GRW index convergence
Ax<-cubit(means$wgrw)
mx<-apply(Ax,c(1,3),mean)
plot(PIs,mx[,3],lwd=2,typ="b",xlab="Characteristic product, PI",
  ylim=range(mx),
  ylab="GRW index",main="GRW index convergence" )
for (w in c(5:length(ws)))
 points(PIs,mx[,w],typ="b",pch=w)
abline(h=0)



plot(means$wgrw,means$shp,main="GEV shape ~ Gringorten-Cook-Harris index equivalence",
      xlab=expression("GRW index, "~italic(w)),ylab=expression("GEV shape, "~italic(xi)))



#=============================================================================================

	levels<-c(-1,0,1,2,5)
	levels<-c(levels/10000,levels/1000,levels/100,levels/10,levels,levels*10,levels*100)
	pal = col = hcl.colors(100, "YlOrRd", rev = TRUE)

MRI=50
R=20
method<-"G"

 Mx<-variances[variances$R==R,]
 XName<-paste("X",MRI,sep="")

 VX<-Mx[,XName]

Name<-paste(method,MRI,sep="")
  V<-Mx[,Name]/VX
  V<-sqrt(V)
 mx<-interp(Mx$PI,Mx$w,V,nx=nPI*10,ny=nw*10,linear=TRUE)
 dev.new()
 image(mx$x,mx$y,log(mx$z),
  main=bquote(bold("Standard error ratio"~.(Name)~"/"~.(XName)~" for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
    xlab=expression("Characteristic product, "~italic(Pi)),col=pal)
 contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
 mtext(bquote("Mean = "~.(round(mean(V),2))))
Print(paste("Mean ratio =",round(mean(V),2)))




